
uniform sampler2D tex;
uniform sampler2D shadow;
uniform sampler3D ntex;

varying vec3 shimmer;

varying vec2 coord_shadow;
varying vec3 normal, lightDir, halfVector;
varying vec4 pos;

void main() {

        vec3 halfV, viewV, ldir;
        float NdotL, NdotHV;

//        vec4 color = texture2D(tex, vec2(gl_TexCoord[1]));
        // fire
        const vec3 light1 = vec3(1.0, 0.6, 0.0);       // front light
        const vec3 light2 = vec3(0.0, 0.6, 0.8) * 0.4; // back light
        const vec3 spec = vec3(0.12, 0.09, 0.04);       // specular highlight color
        vec4 color = vec4(0.7, 0.0, 0.1, 1.0);

/*
        // cool blue
        const vec3 light1 = vec3(0.6, 0.8, 1.0) * 0.6; // front light
        const vec3 light2 = vec3(0.8, 0.4, 0.4) * 0.4; // back light
        const vec3 spec = vec3(0.05, 0.05, 0.1);       // specular highlight color
        vec4 color = vec4(0.4, 0.4, 0.5, 1.0);
*/

        vec3 p = pos.xyz * shimmer;

        vec4 c1 = texture3D(ntex, p*0.05);
        vec4 c2 = texture3D(ntex, p*0.07);

        vec4 d1 = texture3D(ntex, pos.xyz*0.15);
        vec4 d2 = texture3D(ntex, pos.xyz*0.27);

        color.rgb += ((d1 * 0.1) - (d2 * 0.1)).rgb;

        vec3 n1 = c1.rgb * 2.0 - 1.0;
        vec3 n2 = c2.rgb * 2.0 - 1.0;
        vec3 n = n1 + n2;

//        NdotL = max(dot(n, lightDir), 0.0);
        NdotL = dot(n, lightDir);

        if (NdotL > 0.0) {
                color.rgb += light1 * NdotL;
                halfV = normalize(halfVector);
                NdotHV = max(dot(n, halfV), 0.0);
                color.rgb += spec * pow(NdotHV, 16.0); // specular shininess
        } else {
                color.rgb += light2 * NdotL;
                halfV = normalize(halfVector);
                NdotHV = max(-dot(n, halfV), 0.0);
                color.rgb += spec * pow(NdotHV, 16.0); // specular shininess
        }

        vec4 texel = texture2D(shadow, coord_shadow);
        float a = texel.a;
        gl_FragColor.rgb = mix(color.rgb, texel.rgb, a);
        gl_FragColor.a = color.a;
}
